]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
Tolerate zlib deflation with window size < 32Kb
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
28a94f88 46unset EMAIL
95a1d12e
JN
47unset $(perl -e '
48 my @env = keys %ENV;
730477f1
JL
49 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
59 print join("\n", @vars);
60')
29e55cd5
JH
61GIT_AUTHOR_EMAIL=author@example.com
62GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
63GIT_COMMITTER_EMAIL=committer@example.com
64GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f
SP
65GIT_MERGE_VERBOSITY=5
66export GIT_MERGE_VERBOSITY
29e55cd5
JH
67export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 69export EDITOR
e1970ce4 70
886a3907
JH
71# Protect ourselves from common misconfiguration to export
72# CDPATH into the environment
73unset CDPATH
74
5565f47c
BW
75unset GREP_OPTIONS
76
3d5c0cc9 77case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
78 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
83 ;;
84esac
85
cd3c095c
JH
86# Convenience
87#
88# A regexp to match 5 and 40 hexdigits
89_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91
3749fde5
JH
92# Zero SHA-1
93_z40=0000000000000000000000000000000000000000
94
e1970ce4
JH
95# Each test should start with something like this, after copyright notices:
96#
97# test_description='Description of this test...
98# This test checks if command xyzzy does the right thing...
99# '
100# . ./test-lib.sh
c2116a17
JH
101[ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
103 export TERM &&
104 [ -t 1 ] &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
108 ) &&
55db1df0 109 color=t
e1970ce4 110
e1970ce4
JH
111while test "$#" -ne 0
112do
113 case "$1" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t; shift ;;
886856ab
JH
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
5e2c08c6 118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 120 -h|--h|--he|--hel|--help)
570f3226 121 help=t; shift ;;
e1970ce4
JH
122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123 verbose=t; shift ;;
1ece1274 124 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
125 # Ignore --quiet under a TAP::Harness. Saying how many tests
126 # passed without the ok/not ok details is always an error.
127 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
128 --with-dashes)
129 with_dashes=t; shift ;;
55db1df0 130 --no-color)
faa4bc35 131 color=; shift ;;
4e1be63c 132 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 133 valgrind=t; verbose=t; shift ;;
44138559
JS
134 --tee)
135 shift ;; # was handled already
f423ef5f
JK
136 --root=*)
137 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138 shift ;;
e1970ce4 139 *)
1f729dca 140 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
141 esac
142done
143
55db1df0
PH
144if test -n "$color"; then
145 say_color () {
c2116a17
JH
146 (
147 TERM=$ORIGINAL_TERM
148 export TERM
55db1df0
PH
149 case "$1" in
150 error) tput bold; tput setaf 1;; # bold red
151 skip) tput bold; tput setaf 2;; # bold green
152 pass) tput setaf 2;; # green
153 info) tput setaf 3;; # brown
1ece1274 154 *) test -n "$quiet" && return;;
55db1df0
PH
155 esac
156 shift
5099b99d 157 printf "%s" "$*"
55db1df0 158 tput sgr0
b8eecafd 159 echo
c2116a17 160 )
55db1df0
PH
161 }
162else
163 say_color() {
1ece1274 164 test -z "$1" && test -n "$quiet" && return
55db1df0 165 shift
5099b99d 166 echo "$*"
55db1df0
PH
167 }
168fi
169
170error () {
171 say_color error "error: $*"
6e7b5aaf 172 GIT_EXIT_OK=t
55db1df0
PH
173 exit 1
174}
175
176say () {
177 say_color info "$*"
178}
179
570f3226
MB
180test "${test_description}" != "" ||
181error "Test script did not set test_description."
182
183if test "$help" = "t"
184then
185 echo "$test_description"
186 exit 0
187fi
188
4d9d62fa 189exec 5>&1
e1970ce4
JH
190if test "$verbose" = "t"
191then
192 exec 4>&2 3>&1
193else
194 exec 4>/dev/null 3>/dev/null
195fi
196
197test_failure=0
198test_count=0
41ac414e
JH
199test_fixed=0
200test_broken=0
2d84e9fb 201test_success=0
e1970ce4 202
d998bd4a
ÆAB
203test_external_has_tap=0
204
faa4bc35 205die () {
6e7b5aaf
CB
206 code=$?
207 if test -n "$GIT_EXIT_OK"
208 then
209 exit $code
210 else
211 echo >&5 "FATAL: Unexpected exit with code $code"
212 exit 1
213 fi
faa4bc35
CB
214}
215
6e7b5aaf 216GIT_EXIT_OK=
35641310 217trap 'die' EXIT
41184273 218
02b35660
BD
219# The semantics of the editor variables are that of invoking
220# sh -c "$EDITOR \"$@\"" files ...
221#
222# If our trash directory contains shell metacharacters, they will be
223# interpreted if we just set $EDITOR directly, so do a little dance with
224# environment variables to work around this.
225#
226# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 227# that we're using.
02b35660
BD
228test_set_editor () {
229 FAKE_EDITOR="$1"
230 export FAKE_EDITOR
d33738d7
JN
231 EDITOR='"$FAKE_EDITOR"'
232 export EDITOR
02b35660
BD
233}
234
68cfc6f5 235test_decode_color () {
a471833d
KB
236 awk '
237 function name(n) {
238 if (n == 0) return "RESET";
239 if (n == 1) return "BOLD";
240 if (n == 30) return "BLACK";
241 if (n == 31) return "RED";
242 if (n == 32) return "GREEN";
243 if (n == 33) return "YELLOW";
244 if (n == 34) return "BLUE";
245 if (n == 35) return "MAGENTA";
246 if (n == 36) return "CYAN";
247 if (n == 37) return "WHITE";
248 if (n == 40) return "BLACK";
249 if (n == 41) return "BRED";
250 if (n == 42) return "BGREEN";
251 if (n == 43) return "BYELLOW";
252 if (n == 44) return "BBLUE";
253 if (n == 45) return "BMAGENTA";
254 if (n == 46) return "BCYAN";
255 if (n == 47) return "BWHITE";
256 }
257 {
c2ed29b4 258 while (match($0, /\033\[[0-9;]*m/) != 0) {
a471833d
KB
259 printf "%s<", substr($0, 1, RSTART-1);
260 codes = substr($0, RSTART+2, RLENGTH-3);
261 if (length(codes) == 0)
262 printf "%s", name(0)
263 else {
264 n = split(codes, ary, ";");
265 sep = "";
266 for (i = 1; i <= n; i++) {
267 printf "%s%s", sep, name(ary[i]);
268 sep = ";"
269 }
270 }
271 printf ">";
272 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
273 }
274 print
275 }
276 '
68cfc6f5
MG
277}
278
9130ac9f
JK
279nul_to_q () {
280 perl -pe 'y/\000/Q/'
281}
282
c4f3f551
SB
283q_to_nul () {
284 perl -pe 'y/Q/\000/'
285}
286
287q_to_cr () {
288 tr Q '\015'
289}
290
800f1104
JN
291q_to_tab () {
292 tr Q '\011'
293}
294
c4f3f551
SB
295append_cr () {
296 sed -e 's/$/Q/' | tr Q '\015'
297}
298
299remove_cr () {
300 tr '\015' Q | sed -e 's/Q$//'
301}
302
00648ba0
EN
303# In some bourne shell implementations, the "unset" builtin returns
304# nonzero status when a variable to be unset was not set in the first
305# place.
306#
307# Use sane_unset when that should not be considered an error.
308
309sane_unset () {
310 unset "$@"
311 return 0
312}
313
04509738
JH
314test_tick () {
315 if test -z "${test_tick+set}"
316 then
21afc41c 317 test_tick=1112911993
04509738
JH
318 else
319 test_tick=$(($test_tick + 60))
320 fi
21afc41c
JH
321 GIT_COMMITTER_DATE="$test_tick -0700"
322 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
323 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
324}
e1970ce4 325
00884968
JS
326# Call test_commit with the arguments "<message> [<file> [<contents>]]"
327#
328# This will commit a file with the given contents and the given commit
329# message. It will also add a tag with <message> as name.
330#
331# Both <file> and <contents> default to <message>.
332
333test_commit () {
e656fc97 334 file=${2:-"$1.t"}
00884968
JS
335 echo "${3-$1}" > "$file" &&
336 git add "$file" &&
337 test_tick &&
338 git commit -m "$1" &&
339 git tag "$1"
340}
341
342# Call test_merge with the arguments "<message> <commit>", where <commit>
343# can be a tag pointing to the commit-to-merge.
344
345test_merge () {
346 test_tick &&
347 git merge -m "$1" "$2" &&
348 git tag "$1"
349}
350
1f553918
JS
351# This function helps systems where core.filemode=false is set.
352# Use it instead of plain 'chmod +x' to set or unset the executable bit
353# of a file in the working directory and add it to the index.
354
355test_chmod () {
356 chmod "$@" &&
357 git update-index --add "--chmod=$@"
358}
359
a7bb3940
JS
360# Use test_set_prereq to tell that a particular prerequisite is available.
361# The prerequisite can later be checked for in two ways:
362#
363# - Explicitly using test_have_prereq.
364#
365# - Implicitly by specifying the prerequisite tag in the calls to
366# test_expect_{success,failure,code}.
367#
368# The single parameter is the prerequisite tag (a simple word, in all
369# capital letters by convention).
370
371test_set_prereq () {
372 satisfied="$satisfied$1 "
373}
374satisfied=" "
375
376test_have_prereq () {
93a57246
ÆAB
377 # prerequisites can be concatenated with ','
378 save_IFS=$IFS
379 IFS=,
380 set -- $*
381 IFS=$save_IFS
ce60653e
ÆAB
382
383 total_prereq=0
384 ok_prereq=0
385 missing_prereq=
386
93a57246
ÆAB
387 for prerequisite
388 do
ce60653e 389 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
390 case $satisfied in
391 *" $prerequisite "*)
ce60653e
ÆAB
392 ok_prereq=$(($ok_prereq + 1))
393 ;;
93a57246 394 *)
ce60653e
ÆAB
395 # Keep a list of missing prerequisites
396 if test -z "$missing_prereq"
397 then
398 missing_prereq=$prerequisite
399 else
400 missing_prereq="$prerequisite,$missing_prereq"
401 fi
93a57246
ÆAB
402 esac
403 done
ce60653e
ÆAB
404
405 test $total_prereq = $ok_prereq
a7bb3940
JS
406}
407
05236a5e
JN
408test_declared_prereq () {
409 case ",$test_prereq," in
410 *,$1,*)
411 return 0
412 ;;
413 esac
414 return 1
415}
416
886856ab
JH
417# You are not expected to call test_ok_ and test_failure_ directly, use
418# the text_expect_* functions instead.
419
420test_ok_ () {
d5d9de1b 421 test_success=$(($test_success + 1))
5099b99d 422 say_color "" "ok $test_count - $@"
e1970ce4
JH
423}
424
886856ab 425test_failure_ () {
d5d9de1b 426 test_failure=$(($test_failure + 1))
5099b99d 427 say_color error "not ok - $test_count $1"
bf0dd8a8 428 shift
5099b99d 429 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 430 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
431}
432
41ac414e 433test_known_broken_ok_ () {
41ac414e 434 test_fixed=$(($test_fixed+1))
5099b99d 435 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
436}
437
438test_known_broken_failure_ () {
41ac414e 439 test_broken=$(($test_broken+1))
5099b99d 440 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 441}
886856ab
JH
442
443test_debug () {
8e832ebc 444 test "$debug" = "" || eval "$1"
e1970ce4
JH
445}
446
4d9d62fa 447test_run_ () {
b6b0afdc 448 test_cleanup=:
b586744a 449 expecting_failure=$2
4d9d62fa 450 eval >&3 2>&4 "$1"
b6b0afdc 451 eval_ret=$?
b586744a
JH
452
453 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
454 then
455 eval >&3 2>&4 "$test_cleanup"
456 fi
57e1538a
ÆAB
457 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
458 echo ""
459 fi
4d9d62fa
PR
460 return 0
461}
462
04ece593 463test_skip () {
8586f98b 464 test_count=$(($test_count+1))
04ece593
JH
465 to_skip=
466 for skp in $GIT_SKIP_TESTS
467 do
8586f98b 468 case $this_test.$test_count in
04ece593
JH
469 $skp)
470 to_skip=t
47e67d47 471 break
04ece593
JH
472 esac
473 done
05236a5e
JN
474 if test -z "$to_skip" && test -n "$test_prereq" &&
475 ! test_have_prereq "$test_prereq"
a7bb3940
JS
476 then
477 to_skip=t
478 fi
04ece593
JH
479 case "$to_skip" in
480 t)
07431fc8 481 of_prereq=
05236a5e 482 if test "$missing_prereq" != "$test_prereq"
07431fc8 483 then
05236a5e 484 of_prereq=" of $test_prereq"
07431fc8
JN
485 fi
486
55db1df0 487 say_color skip >&3 "skipping test: $@"
07431fc8 488 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
489 : true
490 ;;
491 *)
492 false
493 ;;
494 esac
495}
496
e1970ce4 497test_expect_failure () {
05236a5e 498 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 499 test "$#" = 2 ||
a7bb3940 500 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
05236a5e 501 export test_prereq
04ece593 502 if ! test_skip "$@"
e1970ce4 503 then
41ac414e 504 say >&3 "checking known breakage: $2"
b586744a 505 test_run_ "$2" expecting_failure
41ac414e 506 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 507 then
41ac414e 508 test_known_broken_ok_ "$1"
04ece593 509 else
6e7b5aaf 510 test_known_broken_failure_ "$1"
04ece593 511 fi
e1970ce4 512 fi
7a0cf2d0 513 echo >&3 ""
e1970ce4
JH
514}
515
516test_expect_success () {
05236a5e 517 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 518 test "$#" = 2 ||
a7bb3940 519 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
05236a5e 520 export test_prereq
04ece593 521 if ! test_skip "$@"
e1970ce4 522 then
04ece593
JH
523 say >&3 "expecting success: $2"
524 test_run_ "$2"
525 if [ "$?" = 0 -a "$eval_ret" = 0 ]
526 then
527 test_ok_ "$1"
528 else
529 test_failure_ "$@"
530 fi
e1970ce4 531 fi
7a0cf2d0 532 echo >&3 ""
e1970ce4
JH
533}
534
fb32c410
LW
535# test_external runs external test scripts that provide continuous
536# test output about their progress, and succeeds/fails on
537# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 538# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
539# <n>: ..." before running it. When providing relative paths, keep in
540# mind that all scripts run in "trash directory".
541# Usage: test_external description command arguments...
542# Example: test_external 'Perl API' perl ../path/to/test.pl
543test_external () {
05236a5e 544 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
a7bb3940
JS
545 test "$#" = 3 ||
546 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
547 descr="$1"
548 shift
05236a5e 549 export test_prereq
fb32c410
LW
550 if ! test_skip "$descr" "$@"
551 then
552 # Announce the script to reduce confusion about the
553 # test output that follows.
d998bd4a 554 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
555 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
556 # to be able to use them in script
557 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
558 # Run command; redirect its stderr to &4 as in
559 # test_run_, but keep its stdout on our stdout even in
560 # non-verbose mode.
561 "$@" 2>&4
562 if [ "$?" = 0 ]
563 then
d998bd4a
ÆAB
564 if test $test_external_has_tap -eq 0; then
565 test_ok_ "$descr"
566 else
567 say_color "" "# test_external test $descr was ok"
568 test_success=$(($test_success + 1))
569 fi
fb32c410 570 else
d998bd4a
ÆAB
571 if test $test_external_has_tap -eq 0; then
572 test_failure_ "$descr" "$@"
573 else
574 say_color error "# test_external test $descr failed: $@"
575 test_failure=$(($test_failure + 1))
576 fi
fb32c410
LW
577 fi
578 fi
579}
580
581# Like test_external, but in addition tests that the command generated
582# no output on stderr.
583test_external_without_stderr () {
584 # The temporary file has no (and must have no) security
585 # implications.
c54e6be7 586 tmp=${TMPDIR:-/tmp}
fb32c410
LW
587 stderr="$tmp/git-external-stderr.$$.tmp"
588 test_external "$@" 4> "$stderr"
589 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
590 descr="no stderr: $1"
591 shift
d998bd4a 592 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
593 if [ ! -s "$stderr" ]; then
594 rm "$stderr"
d998bd4a
ÆAB
595
596 if test $test_external_has_tap -eq 0; then
597 test_ok_ "$descr"
598 else
599 say_color "" "# test_external_without_stderr test $descr was ok"
600 test_success=$(($test_success + 1))
601 fi
fb32c410
LW
602 else
603 if [ "$verbose" = t ]; then
d998bd4a 604 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
605 else
606 output=
607 fi
608 # rm first in case test_failure exits.
609 rm "$stderr"
d998bd4a
ÆAB
610 if test $test_external_has_tap -eq 0; then
611 test_failure_ "$descr" "$@" "$output"
612 else
613 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
614 test_failure=$(($test_failure + 1))
615 fi
fb32c410
LW
616 fi
617}
618
2caf20c5
MM
619# debugging-friendly alternatives to "test [-f|-d|-e]"
620# The commands test the existence or non-existence of $1. $2 can be
621# given to provide a more precise diagnosis.
622test_path_is_file () {
623 if ! [ -f "$1" ]
624 then
625 echo "File $1 doesn't exist. $*"
626 false
627 fi
628}
629
630test_path_is_dir () {
631 if ! [ -d "$1" ]
632 then
633 echo "Directory $1 doesn't exist. $*"
634 false
635 fi
636}
637
638test_path_is_missing () {
639 if [ -e "$1" ]
640 then
641 echo "Path exists:"
642 ls -ld "$1"
643 if [ $# -ge 1 ]; then
644 echo "$*"
645 fi
646 false
647 fi
648}
649
fb3340a6
JN
650# test_line_count checks that a file has the number of lines it
651# ought to. For example:
652#
653# test_expect_success 'produce exactly one line of output' '
654# do something >output &&
655# test_line_count = 1 output
656# '
657#
658# is like "test $(wc -l <output) = 1" except that it passes the
659# output through when the number of lines is wrong.
660
661test_line_count () {
662 if test $# != 3
663 then
664 error "bug in the test script: not 3 parameters to test_line_count"
665 elif ! test $(wc -l <"$3") "$1" "$2"
666 then
667 echo "test_line_count: line count for $3 !$1 $2"
668 cat "$3"
669 return 1
670 fi
671}
2caf20c5 672
74359821
JH
673# This is not among top-level (test_expect_success | test_expect_failure)
674# but is a prefix that can be used in the test script, like:
675#
676# test_expect_success 'complain and die' '
677# do something &&
678# do something else &&
679# test_must_fail git checkout ../outerspace
680# '
681#
682# Writing this as "! git checkout ../outerspace" is wrong, because
683# the failure could be due to a segv. We want a controlled failure.
684
685test_must_fail () {
686 "$@"
16034fbe
JK
687 exit_code=$?
688 if test $exit_code = 0; then
689 echo >&2 "test_must_fail: command succeeded: $*"
690 return 1
691 elif test $exit_code -gt 129 -a $exit_code -le 192; then
692 echo >&2 "test_must_fail: died by signal: $*"
693 return 1
a54ce3ca
JK
694 elif test $exit_code = 127; then
695 echo >&2 "test_must_fail: command not found: $*"
696 return 1
16034fbe
JK
697 fi
698 return 0
74359821
JH
699}
700
fdf1bc48
JN
701# Similar to test_must_fail, but tolerates success, too. This is
702# meant to be used in contexts like:
703#
704# test_expect_success 'some command works without configuration' '
705# test_might_fail git config --unset all.configuration &&
706# do something
707# '
708#
709# Writing "git config --unset all.configuration || :" would be wrong,
710# because we want to notice if it fails due to segv.
711
712test_might_fail () {
713 "$@"
5c8e1414
JN
714 exit_code=$?
715 if test $exit_code -gt 129 -a $exit_code -le 192; then
716 echo >&2 "test_might_fail: died by signal: $*"
717 return 1
d0b8a617
JN
718 elif test $exit_code = 127; then
719 echo >&2 "test_might_fail: command not found: $*"
720 return 1
5c8e1414
JN
721 fi
722 return 0
fdf1bc48
JN
723}
724
892e6f7e
ÆAB
725# Similar to test_must_fail and test_might_fail, but check that a
726# given command exited with a given exit code. Meant to be used as:
727#
728# test_expect_success 'Merge with d/f conflicts' '
729# test_expect_code 1 git merge "merge msg" B master
730# '
731
732test_expect_code () {
733 want_code=$1
734 shift
735 "$@"
736 exit_code=$?
737 if test $exit_code = $want_code
738 then
892e6f7e 739 return 0
892e6f7e 740 fi
f5b7ce1b
JN
741
742 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
743 return 1
892e6f7e
ÆAB
744}
745
82ebb0b6
JK
746# test_cmp is a helper function to compare actual and expected output.
747# You can use it like:
748#
749# test_expect_success 'foo works' '
750# echo expected >expected &&
751# foo >actual &&
752# test_cmp expected actual
753# '
754#
755# This could be written as either "cmp" or "diff -u", but:
756# - cmp's output is not nearly as easy to read as diff -u
757# - not all diff versions understand "-u"
758
759test_cmp() {
760 $GIT_TEST_CMP "$@"
761}
762
3bf78867
JN
763# This function can be used to schedule some commands to be run
764# unconditionally at the end of the test to restore sanity:
765#
766# test_expect_success 'test core.capslock' '
767# git config core.capslock true &&
768# test_when_finished "git config --unset core.capslock" &&
769# hello world
770# '
771#
772# That would be roughly equivalent to
773#
774# test_expect_success 'test core.capslock' '
775# git config core.capslock true &&
776# hello world
777# git config --unset core.capslock
778# '
779#
780# except that the greeting and config --unset must both succeed for
781# the test to pass.
b586744a
JH
782#
783# Note that under --immediate mode, no clean-up is done to help diagnose
784# what went wrong.
3bf78867
JN
785
786test_when_finished () {
b6b0afdc
JN
787 test_cleanup="{ $*
788 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
789}
790
0509eb21 791# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
792# Usage: test_create_repo <directory>
793test_create_repo () {
794 test "$#" = 1 ||
795 error "bug in the test script: not 1 parameter to test-create-repo"
eedf8f97 796 repo="$1"
bfdbee98 797 mkdir -p "$repo"
0d314ce8
ÆAB
798 (
799 cd "$repo" || error "Cannot setup test environment"
800 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
801 error "cannot run git init -- have you built things yet?"
802 mv .git/hooks .git/hooks-disabled
803 ) || exit
eedf8f97 804}
a6080a0a 805
e1970ce4 806test_done () {
6e7b5aaf 807 GIT_EXIT_OK=t
2d84e9fb 808
8ef1abe5
ÆAB
809 if test -z "$HARNESS_ACTIVE"; then
810 test_results_dir="$TEST_DIRECTORY/test-results"
811 mkdir -p "$test_results_dir"
812 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
813
c54e6be7
ML
814 cat >>"$test_results_path" <<-EOF
815 total $test_count
816 success $test_success
817 fixed $test_fixed
818 broken $test_broken
819 failed $test_failure
820
821 EOF
8ef1abe5 822 fi
41ac414e
JH
823
824 if test "$test_fixed" != 0
825 then
5099b99d 826 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
827 fi
828 if test "$test_broken" != 0
829 then
5099b99d 830 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
831 msg="remaining $(($test_count-$test_broken)) test(s)"
832 else
833 msg="$test_count test(s)"
41ac414e 834 fi
e1970ce4 835 case "$test_failure" in
10b94e28 836 0)
5099b99d
ÆAB
837 # Maybe print SKIP message
838 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
839
d998bd4a
ÆAB
840 if test $test_external_has_tap -eq 0; then
841 say_color pass "# passed all $msg"
842 say "1..$test_count$skip_all"
843 fi
abc5d372
JS
844
845 test -d "$remove_trash" &&
846 cd "$(dirname "$remove_trash")" &&
847 rm -rf "$(basename "$remove_trash")"
848
e1970ce4
JH
849 exit 0 ;;
850
851 *)
d998bd4a
ÆAB
852 if test $test_external_has_tap -eq 0; then
853 say_color error "# failed $test_failure among $msg"
854 say "1..$test_count"
855 fi
5099b99d 856
e1970ce4
JH
857 exit 1 ;;
858
859 esac
860}
861
862# Test the binaries we have just built. The tests are kept in
9adefee5 863# t/ subdirectory and are run in 'trash directory' subdirectory.
62f53904
ÆAB
864if test -z "$TEST_DIRECTORY"
865then
866 # We allow tests to override this, in case they want to run tests
867 # outside of t/, e.g. for running tests on the test library
868 # itself.
869 TEST_DIRECTORY=$(pwd)
870fi
6cec5c68
ÆAB
871GIT_BUILD_DIR="$TEST_DIRECTORY"/..
872
e4597aae 873if test -n "$valgrind"
4e1be63c 874then
4e1be63c
JS
875 make_symlink () {
876 test -h "$2" &&
877 test "$1" = "$(readlink "$2")" || {
878 # be super paranoid
879 if mkdir "$2".lock
880 then
881 rm -f "$2" &&
882 ln -s "$1" "$2" &&
883 rm -r "$2".lock
884 else
885 while test -d "$2".lock
886 do
887 say "Waiting for lock on $2."
888 sleep 1
889 done
890 fi
891 }
892 }
893
894 make_valgrind_symlink () {
36bfb0e5
JK
895 # handle only executables, unless they are shell libraries that
896 # need to be in the exec-path. We will just use "#!" as a
897 # guess for a shell-script, since we have no idea what the user
898 # may have configured as the shell path.
899 test -x "$1" ||
900 test "#!" = "$(head -c 2 <"$1")" ||
901 return;
4e1be63c
JS
902
903 base=$(basename "$1")
6cec5c68 904 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
905 # do not override scripts
906 if test -x "$symlink_target" &&
907 test ! -d "$symlink_target" &&
908 test "#!" != "$(head -c 2 < "$symlink_target")"
909 then
910 symlink_target=../valgrind.sh
911 fi
efd92ffd
JS
912 case "$base" in
913 *.sh|*.perl)
914 symlink_target=../unprocessed-script
915 esac
4e1be63c
JS
916 # create the link, or replace it if it is out of date
917 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
918 }
919
920 # override all git executables in TEST_DIRECTORY/..
921 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
922 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 923 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
924 do
925 make_valgrind_symlink $file
926 done
efd92ffd
JS
927 OLDIFS=$IFS
928 IFS=:
929 for path in $PATH
930 do
931 ls "$path"/git-* 2> /dev/null |
932 while read file
933 do
934 make_valgrind_symlink "$file"
935 done
936 done
937 IFS=$OLDIFS
4e1be63c
JS
938 PATH=$GIT_VALGRIND/bin:$PATH
939 GIT_EXEC_PATH=$GIT_VALGRIND/bin
940 export GIT_VALGRIND
e4597aae
MO
941elif test -n "$GIT_TEST_INSTALLED" ; then
942 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
943 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 944 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
945 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
946else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 947 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
948 if ! test -x "$git_bin_dir/git" ; then
949 if test -z "$with_dashes" ; then
950 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
951 fi
952 with_dashes=t
953 fi
954 PATH="$git_bin_dir:$PATH"
6cec5c68 955 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 956 if test -n "$with_dashes" ; then
6cec5c68 957 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 958 fi
4e1be63c 959fi
6cec5c68 960GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 961unset GIT_CONFIG
8bfa6bd6 962GIT_CONFIG_NOSYSTEM=1
3c995beb 963GIT_ATTR_NOSYSTEM=1
8f323c00 964export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 965
aed604c7 966. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 967
5e87eae9
JH
968if test -z "$GIT_TEST_CMP"
969then
970 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
971 then
972 GIT_TEST_CMP="$DIFF -c"
973 else
974 GIT_TEST_CMP="$DIFF -u"
975 fi
976fi
977
6cec5c68 978GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 979export GITPERLLIB
6cec5c68 980test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
981 error "You haven't built things yet, have you?"
982}
e1970ce4 983
ac10a857 984if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 985then
6cec5c68 986 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 987 export GITPYTHONLIB
6cec5c68 988 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
989 error "You haven't built git_remote_helpers yet, have you?"
990 }
991fi
992
6cec5c68 993if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
994 echo >&2 'You need to build test-chmtime:'
995 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
996 exit 1
997fi
998
e1970ce4 999# Test repository
abc5d372 1000test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
1001test -n "$root" && test="$root/$test"
1002case "$test" in
1003/*) TRASH_DIRECTORY="$test" ;;
1004 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1005esac
91c8b825 1006test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 1007rm -fr "$test" || {
6e7b5aaf 1008 GIT_EXIT_OK=t
8d14ac94
JH
1009 echo >&5 "FATAL: Cannot prepare test area"
1010 exit 1
1011}
1012
90cff968
AR
1013HOME="$TRASH_DIRECTORY"
1014export HOME
1015
4a7aaccd 1016test_create_repo "$test"
1bd9c648
LW
1017# Use -P to resolve symlinks in our working directory so that the cwd
1018# in subprocesses like git equals our $PWD (for pathname comparisons).
1019cd -P "$test" || exit 1
04ece593 1020
d5d9de1b
JS
1021this_test=${0##*/}
1022this_test=${this_test%%-*}
04ece593
JH
1023for skp in $GIT_SKIP_TESTS
1024do
47e67d47
MG
1025 case "$this_test" in
1026 $skp)
55db1df0 1027 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 1028 skip_all="skip all tests in $this_test"
04ece593
JH
1029 test_done
1030 esac
1031done
f17e9fbb 1032
8648732e
BC
1033# Provide an implementation of the 'yes' utility
1034yes () {
1035 if test $# = 0
1036 then
1037 y=y
1038 else
1039 y="$*"
1040 fi
1041
1042 while echo "$y"
1043 do
1044 :
1045 done
1046}
1047
f17e9fbb
JS
1048# Fix some commands on Windows
1049case $(uname -s) in
1050*MINGW*)
1051 # Windows has its own (incompatible) sort and find
1052 sort () {
1053 /usr/bin/sort "$@"
1054 }
1055 find () {
1056 /usr/bin/find "$@"
1057 }
5397ea31
JS
1058 sum () {
1059 md5sum "$@"
1060 }
4114156a
JS
1061 # git sees Windows-style pwd
1062 pwd () {
1063 builtin pwd -W
1064 }
ee9fb68c 1065 # no POSIX permissions
6fd1106a 1066 # backslashes in pathspec are converted to '/'
fb9a2bea 1067 # exec does not inherit the PID
a94114ad 1068 test_set_prereq MINGW
a31d0665
RJ
1069 test_set_prereq SED_STRIPS_CR
1070 ;;
1071*CYGWIN*)
1072 test_set_prereq POSIXPERM
a31d0665
RJ
1073 test_set_prereq EXECKEEPSPID
1074 test_set_prereq NOT_MINGW
1075 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
1076 ;;
1077*)
1078 test_set_prereq POSIXPERM
6fd1106a 1079 test_set_prereq BSLASHPSPEC
fb9a2bea 1080 test_set_prereq EXECKEEPSPID
3ba9ba8f 1081 test_set_prereq NOT_MINGW
f17e9fbb
JS
1082 ;;
1083esac
704a3143 1084
1b19ccd2 1085test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1086test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 1087test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1b19ccd2 1088
bb946bba 1089# Can we rely on git's output in the C locale?
30955229
JN
1090if test -n "$GETTEXT_POISON"
1091then
1092 GIT_GETTEXT_POISON=YesPlease
1093 export GIT_GETTEXT_POISON
1094else
1095 test_set_prereq C_LOCALE_OUTPUT
1096fi
bb946bba 1097
cabdee2c
JH
1098# Use this instead of test_cmp to compare files that contain expected and
1099# actual output from git commands that can be translated. When running
1100# under GETTEXT_POISON this pretends that the command produced expected
1101# results.
1102test_i18ncmp () {
1103 test -n "$GETTEXT_POISON" || test_cmp "$@"
1104}
1105
127df8c6
JH
1106# Use this instead of "grep expected-string actual" to see if the
1107# output from a git command that can be translated either contains an
1108# expected string, or does not contain an unwanted one. When running
1109# under GETTEXT_POISON this pretends that the command produced expected
1110# results.
1111test_i18ngrep () {
1112 if test -n "$GETTEXT_POISON"
1113 then
1114 : # pretend success
1115 elif test "x!" = "x$1"
1116 then
1117 shift
1118 ! grep "$@"
1119 else
1120 grep "$@"
1121 fi
1122}
1123
704a3143
JS
1124# test whether the filesystem supports symbolic links
1125ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1126rm -f y
c91cfd19
ÆAB
1127
1128# When the tests are run as root, permission tests will report that
1129# things are writable when they shouldn't be.
1130test -w / || test_set_prereq SANITY